/**
 * Appcelerator Titanium Mobile
 * Copyright (c) 2011-2012 by Appcelerator, Inc. All Rights Reserved.
 * Licensed under the terms of the Apache Public License
 * Please see the LICENSE included with this distribution for details.
 */

package com.findlaw.c2dm;

import org.mozilla.javascript.Context;
import org.mozilla.javascript.IdFunctionObject;
import org.mozilla.javascript.Scriptable;
import org.mozilla.javascript.ScriptableObject;
import org.mozilla.javascript.Undefined;

import org.appcelerator.kroll.KrollDict;
import org.appcelerator.kroll.KrollInvocation;
import org.appcelerator.kroll.KrollModule;
import org.appcelerator.kroll.KrollProxy;
import org.appcelerator.kroll.KrollProxySupport;
import org.appcelerator.kroll.KrollRuntime;

import org.appcelerator.kroll.common.TiConfig;

import org.appcelerator.kroll.runtime.rhino.KrollBindings;
import org.appcelerator.kroll.runtime.rhino.KrollGeneratedBindings;
import org.appcelerator.kroll.runtime.rhino.Proxy;
import org.appcelerator.kroll.runtime.rhino.ProxyFactory;
import org.appcelerator.kroll.runtime.rhino.RhinoRuntime;
import org.appcelerator.kroll.runtime.rhino.TypeConverter;
import org.appcelerator.kroll.common.Log;

import java.util.HashMap;

import com.findlaw.c2dm.C2dmModule;

import org.appcelerator.kroll.KrollModulePrototype;


public class C2dmModulePrototype extends KrollModulePrototype
{
	// GENERATE_SUID

	private static final boolean DBG = TiConfig.LOGD;
	private static final String TAG = "C2dmModulePrototype";
	private static final String CLASS_TAG = "C2dmModule";
	private static C2dmModulePrototype c2dmModulePrototype;


	public static C2dmModulePrototype getProxyPrototype()
	{
		return c2dmModulePrototype;
	}

	public static void dispose()
	{
		if (DBG) {
			Log.d(TAG, "dispose()");
		}
		c2dmModulePrototype = null;
	}

	public C2dmModulePrototype()
	{
		if (c2dmModulePrototype == null && getClass().equals(C2dmModulePrototype.class)) {
			c2dmModulePrototype = this;
			KrollGeneratedBindings.registerUsedPrototypeClass(getClass());
		}

		isModule = true;
	}

	public Scriptable getPrototype()
	{
		if (this == c2dmModulePrototype) {
			return KrollModulePrototype.getProxyPrototype();
		}
		return c2dmModulePrototype;
	}

	protected Class<? extends Proxy> getParent()
	{
		return KrollModulePrototype.class;
	}

	protected KrollProxySupport createProxy(String creationUrl, Object[] args)
	{
		return KrollProxy.createProxy(C2dmModule.class, getRhinoObject(), args, creationUrl);
	}

	// Methods
	public void registerC2dm(Context context, Scriptable thisObj, Object[] args)
	{
		if (DBG) {
			Log.d(TAG, "registerC2dm()");
		}

		try {
		C2dmModule proxy = (C2dmModule) ((Proxy) thisObj).getProxy();
		if (args.length < 2) {
			throw new IllegalArgumentException("registerC2dm: Invalid number of arguments. Expected 2 but got " + args.length);
		}
		java.lang.String arg0;
		arg0 = (java.lang.String) TypeConverter.jsObjectToJavaString(args[0], thisObj) ;
		java.util.HashMap arg1;
		arg1 = (java.util.HashMap) TypeConverter.jsObjectToJavaObject(args[1], thisObj) ;

		proxy.registerC2dm(arg0, arg1);
	

		} catch (Throwable throwable) {
			Context.throwAsScriptRuntimeEx(throwable);
			
		}
	}

	public void unregister(Context context, Scriptable thisObj, Object[] args)
	{
		if (DBG) {
			Log.d(TAG, "unregister()");
		}

		try {
		C2dmModule proxy = (C2dmModule) ((Proxy) thisObj).getProxy();

		proxy.unregister();
	

		} catch (Throwable throwable) {
			Context.throwAsScriptRuntimeEx(throwable);
			
		}
	}


	// Dynamic properties
	public String getter_registrationId()
	{
		if (DBG) {
			Log.d(TAG, "get registrationId");
		}

		C2dmModule proxy = (C2dmModule) getProxy();
		Scriptable thisObj = this;
		java.lang.String javaResult = proxy.getRegistrationId();

		String rhinoResult = (String) javaResult;
		return rhinoResult;
	}

// #string_id_map#

	// Prototype IDs
	private static final int
		Id_constructor = 1
,		// Property IDs
		// Method IDs
		Id_registerC2dm = 2,
		Id_unregister = 3
;
		

	public static final int MAX_PROTOTYPE_ID = 3;

	protected int getMaxPrototypeId()
	{
		return MAX_PROTOTYPE_ID;
	}

	@Override
	protected int findPrototypeId(String s)
	{
		int id = 0;
// #generated# Last update: 2012-05-17 12:14:33 IST
        L0: { id = 0; String X = null;
            int s_length = s.length();
            if (s_length==10) { X="unregister";id=Id_unregister; }
            else if (s_length==11) { X="constructor";id=Id_constructor; }
            else if (s_length==12) { X="registerC2dm";id=Id_registerC2dm; }
            if (X!=null && X!=s && !X.equals(s)) id = 0;
            break L0;
        }
// #/generated#
		return id;
	}

// #/string_id_map#

	@Override
	protected void initPrototypeId(int id)
	{
		String name;
		int arity;
		switch (id) {
			case Id_constructor:
				arity = 0;
				name = "constructor";
				break;
			case Id_registerC2dm:
				arity = 2;
				name = "registerC2dm";
				break;
			case Id_unregister:
				arity = 0;
				name = "unregister";
				break;
			default:
				super.initPrototypeId(id);
				return;
		}
		initPrototypeMethod(CLASS_TAG, id, name, arity);
	}

	@Override
	public Object execIdCall(IdFunctionObject f,
		Context cx, Scriptable scope, Scriptable thisObj, Object[] args)
	{
		if (!f.hasTag(CLASS_TAG)) {
			return super.execIdCall(f, cx, scope, thisObj, args);
		}

		while (thisObj != null && !(thisObj instanceof C2dmModulePrototype)) {
			thisObj = thisObj.getPrototype();
		}

		C2dmModulePrototype proxy = (C2dmModulePrototype) thisObj;
		int id = f.methodId();
		switch (id) {
			case Id_constructor:
				return jsConstructor(scope, args);
			case Id_registerC2dm:
				 registerC2dm(cx, thisObj, args);
				return Undefined.instance;
			case Id_unregister:
				 unregister(cx, thisObj, args);
				return Undefined.instance;
			default:
				throw new IllegalArgumentException(String.valueOf(id));
		}
	}



// #string_id_map#

	// Instance IDs
	private static final int ISTART = 0;
	// Dynamic property IDs
	private static final int

		Id_registrationId = 1
		;

;

;

	public static final int MAX_INSTANCE_ID = 1;

	@Override
	protected int getMaxInstanceId()
	{
		return MAX_INSTANCE_ID;
	}

	@Override
	protected int findInstanceIdInfo(String s)
	{
		int id = 0;
// #generated# Last update: 2012-05-17 12:14:33 IST
        L0: { id = 0; String X = null;
            if (s.length()==14) { X="registrationId";id=Id_registrationId; }
            if (X!=null && X!=s && !X.equals(s)) id = 0;
            break L0;
        }
// #/generated#
		if (id == 0) {
			return id;
		}
		return instanceIdInfo(PERMANENT, id);
	}

// #/string_id_map#

	@Override
	protected String getInstanceIdName(int id)
	{
		switch (id) {
			case Id_registrationId:
				return "registrationId"; 
			default:
				throw new IllegalArgumentException(String.valueOf(id));
		}
	}

	@Override
	protected Object getInstanceIdValue(int id, Scriptable start)
	{
		C2dmModulePrototype proxy = this;
		while (start != null && !(start instanceof C2dmModulePrototype)) {
			start = start.getPrototype();
		}

		if (start instanceof C2dmModulePrototype) {
			proxy = (C2dmModulePrototype) start;
		}

		switch (id) {
			case Id_registrationId:
				return proxy.getter_registrationId();
			default:
				throw new IllegalArgumentException(String.valueOf(id));
		}
	}

	@Override
	protected void setInstanceIdValue(int id, Scriptable start, Object value)
	{
		Scriptable original = start;
		C2dmModulePrototype proxy = this;
		while (start != null && !(start instanceof C2dmModulePrototype)) {
			start = start.getPrototype();
		}

		if (start instanceof C2dmModulePrototype) {
			proxy = (C2dmModulePrototype) start;
		}

		switch (id) {
			case Id_registrationId:
				proxy.setProperty("registrationId", value);
				proxy.onPropertyChanged("registrationId", value);
				break; 
			default:
				throw new IllegalArgumentException(String.valueOf(id));
		}
	}

	@Override
	public String getClassName()
	{
		return CLASS_TAG;
	}
}
