/**
 * This file was auto-generated by the Titanium Module SDK helper for Android
 * Appcelerator Titanium Mobile
 * Copyright (c) 2009-2010 by Appcelerator, Inc. All Rights Reserved.
 * Licensed under the terms of the Apache Public License
 * Please see the LICENSE included with this distribution for details.
 *
 */
 
package com.findlaw.c2dm;

import org.appcelerator.kroll.KrollInvocation;
import org.appcelerator.kroll.KrollModule;
import org.appcelerator.kroll.annotations.Kroll;

import org.appcelerator.titanium.TiContext;
import org.appcelerator.titanium.TiApplication;
import org.appcelerator.titanium.util.Log;
import java.util.HashMap;
import org.appcelerator.kroll.KrollFunction;

import com.google.android.c2dm.C2DMessaging;

import android.app.AlertDialog;
import android.content.DialogInterface;

@Kroll.module(name="C2dm", id="com.findlaw.c2dm")
public class C2dmModule extends KrollModule
{
	// Standard Debugging variables
	private static final String LCAT = "C2dmModule";
	
	private static C2dmModule _THIS;
	
	private KrollFunction successCallback;
	private KrollFunction errorCallback;
	private KrollFunction messageCallback;
	
	public C2dmModule() {
		super();
		_THIS = this;
	}

	// Methods
	@Kroll.method
	public void registerC2dm(String senderId, HashMap options) {
		Log.d(LCAT, "registerC2dm called");
		
		successCallback = (KrollFunction)options.get("success");
		errorCallback = (KrollFunction)options.get("error");
		messageCallback = (KrollFunction)options.get("callback");
		
		String registrationId = getRegistrationId();
		if(registrationId != null && registrationId.length() > 0) {
			sendSuccess(registrationId);
		} else {
			C2DMessaging.register(TiApplication.getInstance(), senderId);
		}
	}
	
	// Methods
	@Kroll.method
	public void unregister() {
		Log.d(LCAT, "unregister called");
		C2DMessaging.unregister(TiApplication.getInstance());	
	}
		
		
	// Properties
	@Kroll.getProperty
	public String getRegistrationId() {
		Log.d(LCAT, "get registrationId property");
		return C2DMessaging.getRegistrationId(TiApplication.getInstance());
	}
	
	public void sendSuccess(String registrationId) {
		if(successCallback != null) {
			HashMap data = new HashMap();
			data.put("registrationId", registrationId);
		
			successCallback.callAsync(getKrollObject(),data);
		}
	}
	
	public void sendError(String error) {
		if(errorCallback != null) {
			HashMap data = new HashMap();
			data.put("error", error);
		
			errorCallback.callAsync(getKrollObject(),data);
		}
	}
	
	public void sendMessage(HashMap messageData) {
		if(messageCallback != null) {
			HashMap data = new HashMap();
			data.put("data", messageData);
		
			messageCallback.call(getKrollObject(),data);
		}
	}
	
	
	static C2dmModule getInstance() {
		return _THIS;
	}

}
